#!/bin/bash
#
# This script will find all hard drives connected via SATA, and if SMART 
# monitoring is enabled on them, will check the temperature and shut the system 
# down if it's above the temperature threshold of 55°C.

_HOSTNAME=$(hostname -A | head -1)

# Bin paths
SMARTCTL=/usr/sbin/smartctl
GREP=/bin/grep
AWK=/usr/bin/awk
LOGGER=/usr/bin/logger
SYNC=/bin/sync
MAIL=/usr/bin/mail
DOWN=/sbin/shutdown
PUSHOVER=/usr/local/bin/pushover.sh

# Output variables
EMAIL_ADDRESS={{ notification.gmail.email }}
PUSHOVER_USER_KEY={{ notification.pushover.user_key }}
PUSHOVER_APP_TOKEN={{ notification.pushover.roles[current_group_role].disk_temperature_watchdog_token }}

# Possible values
#   * log
#   * pushover
#   * gmail
OUTPUT_METHOD="gmail"

# Misc variables
ALERT_LEVEL=55
DISKS="`/sbin/blkid | grep sd | cut -c 1-8 | uniq`"


# $1: Subject
# $2: Content
_output() {
    case $OUTPUT_METHOD in
        gmail)
            $ECHO "$1" |
            $MAIL -s "$2" "$EMAIL_ADDRESS"
            ;;
    
        pushover)
            $PUSHOVER -U $PUSHOVER_USER_KEY -T $PUSHOVER_APP_TOKEN -t "$1" "$2"
            ;;

        log)
            $LOGGER -t "$0" "$1: $2"
            ;;
    esac
}


for DISK in $DISKS
do
    if [ -b $DISK ]; then
        HDTEMP=$($SMARTCTL -a -d ata $DISK | $GREP -m 1 Temperature | $AWK '{print $10}')

        if [ -z $HDTEMP ]; then
            continue
        fi

        if [ $HDTEMP -ge $ALERT_LEVEL ]; then
            $LOGGER -t "$0" "System going down as hard disk : $DISK temperature $HDTEMP°C crossed its limit"
            $SYNC;$SYNC

            _output "[$_HOSTNAME] System going down" \
                    "System going down as hard disk : $DISK temperature $HDTEMP°C crossed its limit."

            $DOWN -h 0
        fi
    fi
done
